/*
PolyGun

Copyright (c) 2023 mrkubax10 <mrkubax10@onet.pl>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/

#include "game/renderer/legacy_gl/legacy_gl_master_renderer.hpp"

#include "game/renderer/gl/gl_context.hpp"
#include "game/renderer/gl/gl_texture.hpp"
#include "game/renderer/gl/opengl.hpp"
#include "game/renderer/legacy_gl/legacy_gl_mesh_renderer.hpp"
#include "game/renderer/legacy_gl/legacy_gl_gui_renderer.hpp"
#include "game/renderer/legacy_gl/legacy_gl_shader.hpp"
#include "game/renderer/legacy_gl/legacy_gl_mesh.hpp"
#include "game/window/window.hpp"
#include "common/logger.hpp"

using namespace polygun::renderer;

LegacyGLMasterRenderer::LegacyGLMasterRenderer(window::Window* window) :
	MasterRenderer(),
	m_context(nullptr)
{
	if(window->window_creates_gl_context())
		m_context = window->get_window_gl_context();
	else
		m_context = GLContext::create_context(window);
	LOG_INFO("OpenGL version string: %s", glGetString(GL_VERSION));
	LOG_INFO("OpenGL vendor: %s", glGetString(GL_VENDOR));
	LOG_INFO("OpenGL renderer: %s", glGetString(GL_RENDERER));
	m_mesh_renderer.reset(new LegacyGLMeshRenderer);
	m_gui_renderer.reset(new LegacyGLGUIRenderer(this));
}

LegacyGLMasterRenderer::~LegacyGLMasterRenderer() {
	delete m_context;
}

void LegacyGLMasterRenderer::clear_screen(float r, float g, float b) {
	glClearColor(r, g, b, 1.0f);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
}

Shader* LegacyGLMasterRenderer::create_shader() const {
	return new LegacyGLShader;
}

Mesh* LegacyGLMasterRenderer::create_mesh() const {
	return new LegacyGLMesh;
}

Texture* LegacyGLMasterRenderer::create_texture() const {
	return new GLTexture;
}
